var YMColorInverter = (function() {
    var _darkModeBackgroundColorRGB = [],
        _content = document.getElementById("content"),
        _debug = false,
        rgbaTransparent = 'rgba(0, 0, 0, 0)',
        colorNamesMappedToRGBColors = {
            aliceblue: [240, 248, 255, 1],
            antiquewhite: [250, 235, 215, 1],
            aqua: [0, 255, 255, 1],
            aquamarine: [127, 255, 212, 1],
            azure: [240, 255, 255, 1],
            beige: [245, 245, 220, 1],
            bisque: [255, 228, 196, 1],
            black: [0, 0, 0, 1],
            blanchedalmond: [255, 235, 205, 1],
            blue: [0, 0, 255, 1],
            blueviolet: [138, 43, 226, 1],
            brown: [165, 42, 42, 1],
            burlywood: [222, 184, 135, 1],
            cadetblue: [95, 158, 160, 1],
            chartreuse: [127, 255, 0, 1],
            chocolate: [210, 105, 30, 1],
            coral: [255, 127, 80, 1],
            cornflowerblue: [100, 149, 237, 1],
            cornsilk: [255, 248, 220, 1],
            crimson: [220, 20, 60, 1],
            cyan: [0, 255, 255, 1],
            darkblue: [0, 0, 139, 1],
            darkcyan: [0, 139, 139, 1],
            darkgoldenrod: [184, 134, 11, 1],
            darkgray: [169, 169, 169, 1],
            darkgreen: [0, 100, 0, 1],
            darkkhaki: [189, 183, 107, 1],
            darkmagenta: [139, 0, 139, 1],
            darkolivegreen: [85, 107, 47, 1],
            darkorange: [255, 140, 0, 1],
            darkorchid: [153, 50, 204, 1],
            darkred: [139, 0, 0, 1],
            darksalmon: [233, 150, 122, 1],
            darkseagreen: [143, 188, 143, 1],
            darkslateblue: [72, 61, 139, 1],
            darkslategray: [47, 79, 79, 1],
            darkturquoise: [0, 206, 209, 1],
            darkviolet: [148, 0, 211, 1],
            deeppink: [255, 20, 147, 1],
            deepskyblue: [0, 191, 255, 1],
            dimgray: [105, 105, 105, 1],
            dodgerblue: [30, 144, 255, 1],
            feldspar: [209, 146, 117, 1],
            firebrick: [178, 34, 34, 1],
            floralwhite: [255, 250, 240, 1],
            forestgreen: [34, 139, 34, 1],
            fuchsia: [255, 0, 255, 1],
            gainsboro: [220, 220, 220, 1],
            ghostwhite: [248, 248, 255, 1],
            gold: [255, 215, 0, 1],
            goldenrod: [218, 165, 32, 1],
            gray: [128, 128, 128, 1],
            green: [0, 128, 0, 1],
            greenyellow: [173, 255, 47, 1],
            honeydew: [240, 255, 240, 1],
            hotpink: [255, 105, 180, 1],
            indianred: [205, 92, 92, 1],
            indigo: [75, 0, 130, 1],
            ivory: [255, 255, 240, 1],
            khaki: [240, 230, 140, 1],
            lavender: [230, 230, 250, 1],
            lavenderblush: [255, 240, 245, 1],
            lawngreen: [124, 252, 0, 1],
            lemonchiffon: [255, 250, 205, 1],
            lightblue: [173, 216, 230, 1],
            lightcoral: [240, 128, 128, 1],
            lightcyan: [224, 255, 255, 1],
            lightgoldenrodyellow: [250, 250, 210, 1],
            lightgrey: [211, 211, 211, 1],
            lightgreen: [144, 238, 144, 1],
            lightpink: [255, 182, 193, 1],
            lightsalmon: [255, 160, 122, 1],
            lightseagreen: [32, 178, 170, 1],
            lightskyblue: [135, 206, 250, 1],
            lightslateblue: [132, 112, 255, 1],
            lightslategray: [119, 136, 153, 1],
            lightsteelblue: [176, 196, 222, 1],
            lightyellow: [255, 255, 224, 1],
            lime: [0, 255, 0, 1],
            limegreen: [50, 205, 50, 1],
            linen: [250, 240, 230, 1],
            magenta: [255, 0, 255, 1],
            maroon: [128, 0, 0, 1],
            mediumaquamarine: [102, 205, 170, 1],
            mediumblue: [0, 0, 205, 1],
            mediumorchid: [186, 85, 211, 1],
            mediumpurple: [147, 112, 216, 1],
            mediumseagreen: [60, 179, 113, 1],
            mediumslateblue: [123, 104, 238, 1],
            mediumspringgreen: [0, 250, 154, 1],
            mediumturquoise: [72, 209, 204, 1],
            mediumvioletred: [199, 21, 133, 1],
            midnightblue: [25, 25, 112, 1],
            mintcream: [245, 255, 250, 1],
            mistyrose: [255, 228, 225, 1],
            moccasin: [255, 228, 181, 1],
            navajowhite: [255, 222, 173, 1],
            navy: [0, 0, 128, 1],
            oldlace: [253, 245, 230, 1],
            olive: [128, 128, 0, 1],
            olivedrab: [107, 142, 35, 1],
            orange: [255, 165, 0, 1],
            orangered: [255, 69, 0, 1],
            orchid: [218, 112, 214, 1],
            palegoldenrod: [238, 232, 170, 1],
            palegreen: [152, 251, 152, 1],
            paleturquoise: [175, 238, 238, 1],
            palevioletred: [216, 112, 147, 1],
            papayawhip: [255, 239, 213, 1],
            peachpuff: [255, 218, 185, 1],
            peru: [205, 133, 63, 1],
            pink: [255, 192, 203, 1],
            plum: [221, 160, 221, 1],
            powderblue: [176, 224, 230, 1],
            purple: [128, 0, 128, 1],
            red: [255, 0, 0, 1],
            rosybrown: [188, 143, 143, 1],
            royalblue: [65, 105, 225, 1],
            saddlebrown: [139, 69, 19, 1],
            salmon: [250, 128, 114, 1],
            sandybrown: [244, 164, 96, 1],
            seagreen: [46, 139, 87, 1],
            seashell: [255, 245, 238, 1],
            sienna: [160, 82, 45, 1],
            silver: [192, 192, 192, 1],
            skyblue: [135, 206, 235, 1],
            slateblue: [106, 90, 205, 1],
            slategray: [112, 128, 144, 1],
            snow: [255, 250, 250, 1],
            springgreen: [0, 255, 127, 1],
            steelblue: [70, 130, 180, 1],
            tan: [210, 180, 140, 1],
            teal: [0, 128, 128, 1],
            thistle: [216, 191, 216, 1],
            tomato: [255, 99, 71, 1],
            turquoise: [64, 224, 208, 1],
            violet: [238, 130, 238, 1],
            violetred: [208, 32, 144, 1],
            wheat: [245, 222, 179, 1],
            white: [255, 255, 255, 1],
            whitesmoke: [245, 245, 245, 1],
            yellow: [255, 255, 0, 1],
            yellowgreen: [154, 205, 50, 1]
        };

    // Defines regex for detecting colors and how to convert each type to rgb type.
    var colorDefinitions = [{
            regex: /^rgba?\((\d{1,3}),(\d{1,3}),(\d{1,3})(?:\)|$|,(\d*.?\d*))/,
            // example: ['rgb(123, 234, 45)', 'rgb(255,234,245)'],
            convertToRGB: function(regexMatch) {
                const rgbColor = [
                    parseInt(regexMatch[1]),
                    parseInt(regexMatch[2]),
                    parseInt(regexMatch[3])
                ];
                if (regexMatch[4] !== undefined) { // If so, color contains alpha value.
                    rgbColor.push(parseFloat(regexMatch[4]))
                }
                return rgbColor;
            }
        },
        {
            regex: /^#?(\w{2})(\w{2})(\w{2})$/,
            // example: ['#00ff00', '336699'],
            convertToRGB: function(regexMatch) {
                return [
                    parseInt(regexMatch[1], 16),
                    parseInt(regexMatch[2], 16),
                    parseInt(regexMatch[3], 16)
                ];
            }
        },
        {
            regex: /^#?(\w{1})(\w{1})(\w{1})$/,
            // example: ['#fb0', 'f0f'],
            convertToRGB: function(regexMatch) {
                return [
                    parseInt(regexMatch[1] + regexMatch[1], 16),
                    parseInt(regexMatch[2] + regexMatch[2], 16),
                    parseInt(regexMatch[3] + regexMatch[3], 16)
                ];
            }
        }
        // We do not need to account for hsl color definition, because CSSStyleDeclaration will always return rgb for internal, external, and inline CSS, and in color attributes for elements, hsl is not supported.
        // Also all hex colors that are read will be 3-digit or 6-digit hex colors without alpha component. HTML attributes, such as bgcolor and color, are the only places hex colors can be read from our code, and HTML attributes do not support 8-digit hex with alpha component. CSSStyleDeclaration (from internal, external, inline CSS) returns rgb or rgba format.
    ];
    // Each additional color attribute would contribute ~2ms delay. Changing border, border-color's subcomponents such as border-right-color, border-left-color, border-top-color, border-bottom-color would change their color values as well in CSSStyleDeclaration object.
    var _simpleStyleColorAttributes = ['color', 'background-color', "background", "border-top-color", "border-right-color", "border-bottom-color", "border-left-color", "outline-color", "column-rule-color", "text-decoration-color"],
        _htmlColorAttributes = ['bgcolor', 'color'];

    function invertAllColorsForDarkMode() {
        // A dictionary of elements with original text color that needs to be preserved
        const savedTextColorMap = new Map();

        // A dictionary of elements with original background color than needs to be preserved
        const savedBackgroundColorsMap = new Map();

        // If element has a background image, text color cannot change
        saveColorInfo(savedTextColorMap, savedBackgroundColorsMap);

        // A dictionary of images with their original background color. Used to ensure that dark icons with
        // edge transparency will remain visible on dark background.
        const imageBackgroundColorsMap = saveImageBackgroundColors();

        // Hide while conversions are in place. Also insures that all changes to CSS rules
        // are applied on display.
        document.getElementById('content-wrapper').style.display = 'none';

        invertColorsInDom();
        invertColorsInCSSStyleSheets();

        document.getElementById('content-wrapper').style.display = '';
        setTimeout(() => {
            restoreBackgroundColors(savedBackgroundColorsMap);
            adjustTextContrastIfRequired(savedTextColorMap);
            restoreImageBackgroundColors(imageBackgroundColorsMap);
            adjustBorderContrastForAnnotationButtons();
            darkModeStylingtForAttachmentPills();
        }, 0);
    }

    // Document styleSheets include our external CSS as well as internal CSS within script tags/elements.
    function invertColorsInCSSStyleSheets() {
        for (let k = 0; k < document.styleSheets.length; k++) {
            const rules = document.styleSheets[k].cssRules || document.styleSheets[k].rules || [];
            for (let i = 0; i < rules.length; i++) {
                if (rules[i].style === undefined) { continue; }

                const selectorText = rules[i].selectorText || "";
                if (selectorText.indexOf(".attachment-pill") >= 0) { continue } // attachment-pills style dark mode in CSS

                invertCSSColors(rules[i]);
            }
        }
    }

    function invertCSSColors(elementOrCSSRule) {
        let backgroundColorSet = false;
        for (let j = 0; j < _simpleStyleColorAttributes.length; j++) {
            const colorAttribute = _simpleStyleColorAttributes[j];
            const colorValue = elementOrCSSRule.style[colorAttribute];

            // Setting either background or background-color in CSSStyleRule sets both simultaneously so avoid inverting the color twice if background-color is inverted already.
            if (!colorValue || colorValue.length == 0 || (backgroundColorSet && colorAttribute == "background")) { continue; }

            const colorValueInRGB = RGBColor(colorValue);
            if (colorValueInRGB.length === 4) {

                // If background is already dark, keep it as is.
                if (/background|border/.test(colorAttribute) && isDarkEnoughBackgroundColor(...colorValueInRGB)) continue;

                const newColor = invertColor(colorValueInRGB[0], colorValueInRGB[1], colorValueInRGB[2], colorValueInRGB[3], false);
                const priority = elementOrCSSRule.style.getPropertyPriority(colorAttribute);
                elementOrCSSRule.style.setProperty(colorAttribute, newColor, priority);
                if (colorAttribute == "background-color") {
                    backgroundColorSet = true;
                }
            }
        }
    }

    function invertColorsInDom() {
        const walk = document.createTreeWalker(_content,
            NodeFilter.SHOW_ELEMENT,
            null,
            false);
        let n;
        while (n = walk.nextNode()) {
            invertCSSColors(n);
            for (let i = 0; i < _htmlColorAttributes.length; i++) {
                const colorAttribute = _htmlColorAttributes[i];
                const colorValue = n.getAttribute(colorAttribute);
                if (!colorValue || colorValue.length == 0) { continue; }
                const colorValueInRGB = RGBColor(colorValue);
                if (colorValueInRGB.length === 4) {

                    // If background is already dark, keep it as is.
                    if (colorAttribute == "bgcolor" && isDarkEnoughBackgroundColor(...colorValueInRGB)) {
                        continue;
                    }

                    const newColor = invertColor(colorValueInRGB[0], colorValueInRGB[1], colorValueInRGB[2], colorValueInRGB[3], true);
                    n.setAttribute(colorAttribute, newColor);
                }
            }
        }
    }

    // colorString would be in rgb or rgba styles if it is from CSSStyleDeclaration (from internal, external, inline CSS); however, for color attributes like bgcolor or color, colorString may be a hex color.
    function RGBColor(colorString) {
        colorString = colorString.replace(/ /g, '');
        if (colorNamesMappedToRGBColors[colorString]) {
            return colorNamesMappedToRGBColors[colorString];
        }

        for (let i = 0; i < colorDefinitions.length; i++) {
            var matches = colorDefinitions[i].regex.exec(colorString);
            if (matches) {
                const rgbs = colorDefinitions[i].convertToRGB(matches);
                let redRGBValue = rgbs[0];
                let greenRGBValue = rgbs[1];
                let blueRGBValue = rgbs[2];
                let alphaRGBValue;
                if (rgbs.length === 4) {
                   alphaRGBValue = rgbs[3];
                } else {
                   alphaRGBValue = 1;
                }
                // validate/cleanup values
                redRGBValue = (redRGBValue < 0 || isNaN(redRGBValue)) ? 0 : ((redRGBValue > 255) ? 255 : redRGBValue);
                greenRGBValue = (greenRGBValue < 0 || isNaN(greenRGBValue)) ? 0 : ((greenRGBValue > 255) ? 255 : greenRGBValue);
                blueRGBValue = (blueRGBValue < 0 || isNaN(blueRGBValue)) ? 0 : ((blueRGBValue > 255) ? 255 : blueRGBValue);
                alphaRGBValue = (alphaRGBValue < 0 || isNaN(alphaRGBValue)) ? 0 : ((alphaRGBValue > 1) ? 1 : alphaRGBValue)

                return [redRGBValue, greenRGBValue, blueRGBValue, alphaRGBValue];
            }
        }
        return [];
    }

    // Use the backgroundColorRGB which is passed from MessageDetailCell.swift to convert any color. For example, when background color is dark red, converting white color would result in dark red; converting light gray would result in slighly darker red. Dark to light and light to dark, if the background color is dark as they are in dark mode in our app. The formula maintains the unique identity of original color when inverted so that red stays red, blue stays blue, green stays green.
    function invertColor(red, green, blue, alpha, modifyToReturnInHex) {
        const contentColor = [red, green, blue];
        const inverseBackgroundColorRGB = [255.0 - _darkModeBackgroundColorRGB[0], 255.0 - _darkModeBackgroundColorRGB[1], 255.0 - _darkModeBackgroundColorRGB[2]];
        let smallestContentColorToInverseBackgroundColorRatio = 1000;
        for (k = 0; k < 3; k++) {
            let theRatio = contentColor[k] / inverseBackgroundColorRGB[k];
            if (theRatio < smallestContentColorToInverseBackgroundColorRatio) {
                smallestContentColorToInverseBackgroundColorRatio = theRatio;
            }
        }
        smallestContentColorToInverseBackgroundColorRatio = Math.min(smallestContentColorToInverseBackgroundColorRatio, 1.0);
        const commonDenominator = [inverseBackgroundColorRGB[0] * smallestContentColorToInverseBackgroundColorRatio, inverseBackgroundColorRGB[1] * smallestContentColorToInverseBackgroundColorRatio, inverseBackgroundColorRGB[2] * smallestContentColorToInverseBackgroundColorRatio];
        const inverseToBeAddedCorrected = [inverseBackgroundColorRGB[0] - commonDenominator[0], inverseBackgroundColorRGB[1] - commonDenominator[1], inverseBackgroundColorRGB[2] - commonDenominator[2]];
        let invertedContentColor = [contentColor[0] - commonDenominator[0] + inverseToBeAddedCorrected[0], contentColor[1] - commonDenominator[1] + inverseToBeAddedCorrected[1], contentColor[2] - commonDenominator[2] + inverseToBeAddedCorrected[2]];

        let largestedInvertedContentColor = 0;
        for (k = 0; k < 3; k++) {
            if (invertedContentColor[k] > largestedInvertedContentColor) {
                largestedInvertedContentColor = invertedContentColor[k];
            }
        }
        if (largestedInvertedContentColor > 255.0) {
            const toningDownRatio = 255.0 / largestedInvertedContentColor;
            for (k = 0; k < 3; k++) {
                invertedContentColor[k] = invertedContentColor[k] * toningDownRatio;
            }
        }
        const newRed = Math.round(invertedContentColor[0]);
        const newGreen = Math.round(invertedContentColor[1]);
        const newBlue = Math.round(invertedContentColor[2]);
        // Color attributes like bgcolor does not support rgb so need hex in that case.
                       
        if (alpha === 1) {
            return modifyToReturnInHex ? "#" + rgbToHex(newRed) + rgbToHex(newGreen) + rgbToHex(newBlue) : `rgb(${newRed},${newGreen},${newBlue})`;
        } else {
            // Do not add any alpha components to hex color. All hex color need to be in 3-digit or 6-digit hex colors without alpha component. HTML attributes (only places hex colors are inserted to) such as bgcolor and color do not support 8-digit hex with alpha component.
            return modifyToReturnInHex ? "#" + rgbToHex(newRed) + rgbToHex(newGreen) + rgbToHex(newBlue) : `rgba(${newRed},${newGreen},${newBlue},${alpha})`;
        }
    }

    function rgbToHex(rgb) {
        let hex = Number(rgb).toString(16);
        if (hex.length < 2) {
            hex = "0" + hex;
        }
        return hex;
    }

    /**
     * HSL to RGB color conversion
     * @param h hue
     * @param s saturation
     * @param l lightness
     * @returns [r, g, b] array
     * From https://stackoverflow.com/questions/2353211/hsl-to-rgb-color-conversion
     */
    function hslToRgb(h, s, l) {
        var r, g, b;

        if(s == 0){
            r = g = b = l; // achromatic
        }else{
            var hue2rgb = function hue2rgb(p, q, t){
                if(t < 0) t += 1;
                if(t > 1) t -= 1;
                if(t < 1/6) return p + (q - p) * 6 * t;
                if(t < 1/2) return q;
                if(t < 2/3) return p + (q - p) * (2/3 - t) * 6;
                return p;
            }

            var q = l < 0.5 ? l * (1 + s) : l + s - l * s;
            var p = 2 * l - q;
            r = hue2rgb(p, q, h + 1/3);
            g = hue2rgb(p, q, h);
            b = hue2rgb(p, q, h - 1/3);
        }

        return [Math.round(r * 255), Math.round(g * 255), Math.round(b * 255)];
    }

    /**
     * RGB to HSL color conversion
     * @param r red
     * @param g green
     * @param b blue
     * @returns [h, s, l] array
     * From https://stackoverflow.com/questions/2353211/hsl-to-rgb-color-conversion
     */
    function rgbToHsl(r, g, b){
        r /= 255, g /= 255, b /= 255;
        var max = Math.max(r, g, b), min = Math.min(r, g, b);
        var h, s, l = (max + min) / 2;

        if(max == min){
            h = s = 0; // achromatic
        }else{
            var d = max - min;
            s = l > 0.5 ? d / (2 - max - min) : d / (max + min);
            switch(max){
                case r: h = (g - b) / d + (g < b ? 6 : 0); break;
                case g: h = (b - r) / d + 2; break;
                case b: h = (r - g) / d + 4; break;
            }
            h /= 6;
        }

        return [h, s, l];
    }

    /**
     * Get color lightness for a RGB color
     * @param r red
     * @param g green
     * @param b blue
     * @returns color lightness in range 0 to 1
     */
    function rgbColorLightness(r, g, b) {
      return (Math.max(r, g, b) + Math.min(r, g, b)) / (2 * 255);
    }

    /**
     * Get "perceived" color lightness for a background RGB color.
     * @param r red
     * @param g green
     * @param b blue
     * @returns color lightness in range 0 to 1
     */
    function rgbColorPerceivedLightness(r, g, b) {
        const cacheKey = `${[r,g,b]}`;
        let cachedLightness = rgbColorPerceivedLightness.cache.get(cacheKey);
        if (!isNaN(cachedLightness)) {
            //_debug && console.log(`Hit ${cacheKey} ${cachedLightness.toFixed(2)}`)
            return cachedLightness;
        }

        let [hue, saturation, lightness] = rgbToHsl(r, g, b);

        // Some hues, like yellow, are perceived much lighter than what there HSL lightness is, and may result in
        // incorrect contrast comparison. E.g. if we have white text on yellow background, lightness difference
        // is deceiving 0.5 value, but there is no contrast.
        // Based on observation, those are saturated colors with hues in range 40°-190°, 0.11 - 0.52 normalized,
        // (yellow and green tones). As a correction, increase the lightness a notch to approach perceived value.
        if (hue > 0.11 && hue < 0.52 && saturation > 0.5 && lightness > 0.35) {
             // increase lightness by 20%, must be always greater then 50%
            let perceivedLightness = Math.min(1, lightness + 0.2);
            _debug && console.log(`Perceived lightness [${[hue, saturation, lightness].map(v => v.toFixed(2))}] + 0.2 -> ${perceivedLightness.toFixed(2)}`);
            lightness = perceivedLightness;
        }

        // Some hues, like blue, are perceived much darker than what there HSL lightness is, and may result in
        // incorrect contrast comparison (e.g. dark text on blue background).
        // Based on observation, those are saturated colors with hues in in range 220°-280°, 0.6 - 0.78 normalized,
        // (blue tones). As a correction, need to decease lightness a notch to approach perceived value.
        else if (hue > 0.6 && hue < 0.78 && saturation > 0.5 && lightness < 0.65) {
             // decrease lightness by 20%, must be always less then 50%
            let perceivedLightness = Math.max(0, lightness - 0.2);
            _debug && console.log(`Perceived lightness [${[hue, saturation, lightness].map(v => v.toFixed(2))}] - 0.2 -> ${perceivedLightness.toFixed(2)}`);
            lightness = perceivedLightness;
        }

        rgbColorPerceivedLightness.cache.set(cacheKey, lightness);
        return lightness;
    }
    rgbColorPerceivedLightness.cache = new Map();

    /**
     *  Checks if a background color needs inversion for dark mode. Uses 79% color lightness as a threshold.
     * @param r red
     * @param g green
     * @param b blue
     * @param a alpha
     */
    function isDarkEnoughBackgroundColor(r, g, b, a) {
        if (a < 1)  return false; // If alpha component is present, cannot determine lightness
        return rgbColorPerceivedLightness(r, g, b) < 0.7;
    }

    /**
     * Checks if an element has a background image
     * @param computedStyle
     */
    function hasBackgroundImage(computedStyle) {
        const backgroundImage = computedStyle.backgroundImage;
        return backgroundImage && backgroundImage != 'none'; // url or gradient
    }

    /**
     * Extracts a background color for an element.
     * @param element
     * @param ignoresBackgroundImages if false, backgroundImage takes priority over backgroundColor
     * @returns backgroundColor or empty string (no background color)
     */
    function backgroundColorFor({element, ignoresBackgroundImages = true}) {
        while (element) {
            let elementComputedStyle = getComputedStyle(element);

            if (!ignoresBackgroundImages && hasBackgroundImage(elementComputedStyle)) {
                return '';
            }

            let bgColor = elementComputedStyle.backgroundColor || '';
            if (bgColor.length && bgColor != rgbaTransparent) {
                return bgColor;
            }
            element = element.parentElement;
        }
        return '';
    }

    /**
     * Visits all text nodes and adjusts text color lightness if contrast against the background is not strong enough.
     * @param savedTextColorMap
     */
    function adjustTextContrastIfRequired(savedTextColorMap) {

        const adjustedTextColorMap = new Map();

        const treeWalker = document.createTreeWalker(_content, NodeFilter.SHOW_TEXT, null, false);

        let textNode;
        while (textNode = treeWalker.nextNode()) {
            if (!/\S/.test(textNode.nodeValue)) continue;
            const element = textNode.parentNode;

            if (adjustedTextColorMap.has(element)) continue;

            const elementComputedStyle = getComputedStyle(element);
            if (elementComputedStyle.display == 'none') continue;

            // Restoring original text color if saved
            const savedTextColor = savedTextColorMap.get(element);
            if (savedTextColor) {
                const textColor = RGBColor(savedTextColor);
                adjustedTextColorMap.set(element, textColor);
                _debug && console.log(`Restoring saved original text color ${textColor}`);
                continue;
            }

            const elementBackgroundColor = backgroundColorFor({element: element});
            if (!elementBackgroundColor) continue;

            const bgColor = RGBColor(elementBackgroundColor);
            const bgLightness = rgbColorPerceivedLightness(...bgColor);
            const textColor = RGBColor(elementComputedStyle.color);
            const textLightness = rgbColorLightness(...textColor);

            _debug && console.log(`C:${Math.abs(textLightness - bgLightness).toFixed(2)} L:${textLightness.toFixed(2)}/${bgLightness.toFixed(2)} ${bgColor} ${textColor} ${textNode.nodeValue.length} ${textNode.nodeValue.substr(0,20)}`);

            let adjustedTextLightness = adjustedTextContrast(textLightness, bgLightness);
            if (adjustedTextLightness) {
                const hslTextColor = rgbToHsl(...textColor);
                const adjustedTextRGB = hslToRgb(hslTextColor[0], hslTextColor[1],adjustedTextLightness);
                _debug && console.log(`[adjust] Adjusting text contrast ${textLightness.toFixed(2)} -> ${adjustedTextLightness.toFixed(2)} ${adjustedTextRGB}`);
                adjustedTextColorMap.set(element, adjustedTextRGB);
            }
        }

        if (adjustedTextColorMap.size > 0) {
            for (const [element, adjustedTextRGB] of adjustedTextColorMap) {
                const adjustedTextColor = `rgb(${adjustedTextRGB.map(String).join(",")})`;
                element.style.setProperty('color', adjustedTextColor, 'important');
            }
        }
    }

    /**
     * Checks if text has enough contrast against the background.
     * The desired contrast (difference between text and background lightness) is at least 50%.
     * @param textLightness
     * @param backgroundLightness
     * @returns adjusted text color lightness, or undefined if no adjustment is needed
     */
    function adjustedTextContrast(textLightness, backgroundLightness) {
        const maxContrast = backgroundLightness > 0.5 ? backgroundLightness : 1 - backgroundLightness;
        const minDesiredContrast = Math.max(0.5, maxContrast*0.7);
        const contrast = Math.abs(textLightness - backgroundLightness);

        if (contrast >= minDesiredContrast) return;

        const contrastDelta = minDesiredContrast - contrast;
        if (textLightness >= backgroundLightness) {
            if (textLightness + contrastDelta <= 1) {
                return textLightness + contrastDelta;
            }
            else {
                return Math.max(0.05, backgroundLightness - minDesiredContrast);
            }
        } else { //  textLightness < backgroundLightness
            if (textLightness - contrastDelta >= 0.05) {
                return textLightness - contrastDelta;
            }
            else {
                return Math.min(1, backgroundLightness + minDesiredContrast);
            }
        }
    }

    /**
     * MI-19235 The annotation button border color when inverted is too dark against already dark background, and needs custom styling.
     */
    function adjustBorderContrastForAnnotationButtons() {
        document.querySelectorAll('.annotation-button').forEach( button => button.classList.add('dark-mode') );
    }

    // [MI-23744] Attachment pills have custom styling in dark mode
    function darkModeStylingtForAttachmentPills() {
        document.querySelectorAll('#attachments .attachment-pill').forEach( pill => {
            pill.classList.add('dark-mode');
            //Undo the default background image color inversion, where the light mode background color is preserved
            pill.querySelectorAll('.icon').forEach(icon => icon.style.removeProperty('background-color'));
        });
    }

    /**
     * Visits all descendent elements without background color and save their text color
     * @param rootElement
     * @param savedTextColorMap map to store results
     */
    function saveTextColorsForElementTree(rootElement, savedTextColorMap) {
        for (const element of rootElement.children) {
            const elementComputedStyle = getComputedStyle(element);
            const hasBackgroundColor = elementComputedStyle.backgroundColor != rgbaTransparent;
            if (hasBackgroundColor || elementComputedStyle.display == 'none') continue;

            const hasTextContent = Array.from(element.childNodes).find(node => node.nodeType == Node.TEXT_NODE && /\S/.test(node.nodeValue));
            if (hasTextContent) {
                const textColor = elementComputedStyle.color;
                savedTextColorMap.set(element, textColor);
            }

            saveTextColorsForElementTree(element, savedTextColorMap);
        }
    }

    // If element has a background image, text color cannot change
    function saveColorInfo(savedTextColorMap, savedBackgroundColorsMap) {
        for (const element of Array.from(document.all)) {
            const elementComputedStyle = getComputedStyle(element);
            if (hasBackgroundImage(elementComputedStyle)) {
                // Save background color for the element, image might not be covering completely the background
                const backgroundColor = backgroundColorFor({element: element});
                if (backgroundColor != rgbaTransparent) {
                    savedBackgroundColorsMap.set(element, backgroundColor);
                }

                // Save text color for all descendant elements
                saveTextColorsForElementTree(element, savedTextColorMap);
            }
        }
    }

    /**
     * Collect effective background color for all images that do not explicitly set background
     * @returns Map key image value background color
     */
    function saveImageBackgroundColors() {
        const imageBackgroundMap = new Map();

        for (const image of Array.from(document.images)) {
            const imageHasBackground = (getComputedStyle(image).backgroundColor != rgbaTransparent);
            if (imageHasBackground) continue;
            const bgColor = backgroundColorFor({element: image, ignoresBackgroundImages: false});
            if (bgColor) {
                imageBackgroundMap.set(image, bgColor);
            }
        }
        return imageBackgroundMap;
    }

    /**
     * Vector icons and logo images might have dark fill and edge transparency. To ensure they are visible in
     * dark mode, we restore their effective background color used in light mode.
     */
    function restoreImageBackgroundColors(imageBackgroundMap) {
        const isSmallSizeImage = (image) => Math.min(image.naturalWidth, image.naturalHeight) < 16;
        for (const [image, backgroundColor] of imageBackgroundMap) {
            if (image.complete && !isSmallSizeImage(image)) {
                image.style.backgroundColor = backgroundColor;
            }
            else {
                image.addEventListener("load", () => {
                    if (!isSmallSizeImage(image)) {
                        image.style.backgroundColor = backgroundColor;
                    }
                }, false);
            }
        }
    }

    function restoreBackgroundColors(savedBackgroundColorsMap) {
        for (const [element, bgColor] of savedBackgroundColorsMap) {
            if (bgColor) {
                element.style.backgroundColor = bgColor;
            }
        }
    }

    var messageReadDarkModeInvertColors = function(darkModeBackgroundColorRGB) {
        if (darkModeBackgroundColorRGB.length == 3) {
            _darkModeBackgroundColorRGB = darkModeBackgroundColorRGB;
            // Do dark mode conversion ONLY if dark mode is set
            const lightness = rgbColorLightness(..._darkModeBackgroundColorRGB);
            if (lightness < 0.5) {
                const contentRootEl = document.getElementById('content');
                contentRootEl && contentRootEl.classList.add('dark-mode');
                invertAllColorsForDarkMode();
            }
        }
                    
        return true;
    };

    /**
      * Currently message compose is always using light mode. If a selection is pasted into compose, ensure
      * that the content stays light - remove dark background and light text color.
      * Should be called on paste event.
     */
    var messageComposeLightModeHandlePaste = function() {
        // To detect pasted content, tag each element in the DOM with a unique value, before WebView performs
        // the actual paste, and wait for paste to complete.
        const domVersion = Date.now();
        Array.from(document.all).forEach(el => el.ymDomVersion = domVersion);

        window.setTimeout(() => {
            const pastedNodes = Array.from(document.all).filter(el => el.ymDomVersion != domVersion);
            pastedNodes.forEach(el => {
                ["-webkit-tap-highlight-color", "caret-color"].forEach(p => el.style.removeProperty(p));

                // Clear dark backgrounds
                const backgroundColor = getComputedStyle(el).backgroundColor;
                if (backgroundColor != rgbaTransparent) {
                    if (rgbColorPerceivedLightness(...RGBColor(backgroundColor)) < 0.5) {
                        el.removeAttribute('bgcolor');
                        ["background", "background-color"].forEach(p => el.style.removeProperty(p));
                    }
                }

                // Clear light text
                const color = getComputedStyle(el).color;
                if (rgbColorPerceivedLightness(...RGBColor(color)) > 0.5) {
                    el.removeAttribute('color');
                    el.style.removeProperty('color');
                }
            });
        }, 20);
        
        return true;
    }

    // MARK: - Public methods
    // All methods below must return a value to avoid `Fatal error: Bug in WebKit: Received neither result or failure` when evaluated via `WKWebView.evaluateJavaScript()`
    return {
        messageReadDarkModeInvertColors: messageReadDarkModeInvertColors,
        messageComposeLightModeHandlePaste: messageComposeLightModeHandlePaste,
    };
}());
