var webViewAttachmentHandler = (function () {
    var currentRange,
        outlineAttachmentMenuOffsetX = -32,
        inlineMenuOffsetX = 12,
        attachments_area_id = 'yahoo__attachments',

    // MARK: Private methods
    attachmentTapped = function(div, event, attachmentType) {
        window.location = "ios://preview-attachment?url=" + encodeURIComponent(div.getAttribute("download-src"))+"&filename=" + encodeURIComponent(div.getAttribute("filename")) + "&filesize=" + encodeURIComponent(div.getAttribute("filesize"));
    },

    showShareMenu = function() {
        var target, bodyRect, elemRect, x, y, attachmentType;

        if (event instanceof Event) {
            event.preventDefault();
            event.stopPropagation();
        }
        if (event.target) {
            target = event.target;
        } else {
            return;
        }
        attachmentType = target.getAttribute('data-type') || target.parentNode.getAttribute('data-type');
        bodyRect = document.body.getBoundingClientRect();
        elemRect = target.getBoundingClientRect();
        x = elemRect.left + inlineMenuOffsetX;
        y = elemRect.top - bodyRect.top;

        window.location = "ios://share/" + target.getAttribute("data-guid") + "/" + x + ":" + y + "?type=" + attachmentType;
    },
                 
    //Adding ym-img-loaded class to the element will hide the spinner.
    removeSpinner = function(el) {
        //Stop spinner on image load.
        var spinnerClassToBeAdded = "ym-img-loaded";
        el.classList.add(spinnerClassToBeAdded);
    },

    // dynamically adds print header to webview
    addHeader = function(htmlString) {
        var headerID = "yahoo__print-header";
        if (document.getElementById(headerID)) {
            return;
        }
        var headerElement = document.createElement("div");
        headerElement.id = headerID;
        headerElement.innerHTML = htmlString;
        var targetElement = document.getElementById("content_wrapper");
        targetElement.insertBefore(headerElement, targetElement.firstChild);
    };

    return {
        // MARK: Public methods
        attachmentTapped: attachmentTapped,
        showShareMenu: showShareMenu,
        removeSpinner: removeSpinner,
        addHeader: addHeader
    };
}());
